# SbLineProjector Class Reference
[Projector classes (mostly for internal use)]

`#include <Inventor/projectors/SbLineProjector.h>`

Inheritance diagram for SbLineProjector:

List of all members.

## Detailed Description

The SbLineProjector class projects 2D points to 3D points along a line.

The 3D projection of the 2D coordinates is for this projector class constrained to lie along a pre-defined line.

Among other places, this is useful within the translation draggers, like for instance SoTranslate1Dragger, where we want to move "pieces" along one or more axes.

## Public Member Functions

| SbLineProjector (void)
virtual SbProjector * | copy (void) const
virtual SbVec3f | project (const SbVec2f &point)
void | setLine (const SbLine &line)
const SbLine & | getLine (void) const
virtual SbVec3f | getVector (const SbVec2f &viewpos1, const SbVec2f &viewpos2)
virtual SbVec3f | getVector (const SbVec2f &viewpos)
void | setStartPosition (const SbVec2f &viewpos)
void | setStartPosition (const SbVec3f &point)

## Protected Attributes

SbLine | line
SbVec3f | lastPoint

## Constructor & Destructor Documentation

SbLineProjector::SbLineProjector | ( | void |  | ) |

| Constructor. Intializes the projector instance to use a line from <0, 0, 0> to <0, 1, 0>.

## Member Function Documentation

SbProjector * SbLineProjector::copy | ( | void |  | ) | const`[virtual]`

Construct and return a copy of this projector. The caller is responsible for destructing the new instance.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable is using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Implements SbProjector.

SbVec3f SbLineProjector::project | ( | const SbVec2f & | point | ) | `[virtual]`

| Project the 2D point from normalized viewport coordinates to a 3D point. The mapping will be done in accordance with the type of the projector. Implements SbProjector.

void SbLineProjector::setLine | ( | const SbLine & | line | ) |

| Set a new projection line. 3D points will be mapped to be on this line.

const SbLine & SbLineProjector::getLine | ( | void |  | ) | const

| Returns the currently set projection line.

SbVec3f SbLineProjector::getVector | ( | const SbVec2f & | viewpos1,
|  | const SbVec2f & | viewpos2
| ) | `[virtual]`

| Calculates and returns a vector between the projected 3D position of viewpos1 and viewpos2.

SbVec3f SbLineProjector::getVector | ( | const SbVec2f & | viewpos | ) | `[virtual]`

| Returns the 3D vector between the last projection and the one calculated for viewpos.

void SbLineProjector::setStartPosition | ( | const SbVec2f & | viewpos | ) |

| Explicitly set position of initial projection, so we get correct values for later calls to getVector() etc.

void SbLineProjector::setStartPosition | ( | const SbVec3f & | point | ) |

| Explicitly set position of initial projection, so we get correct values for later calls to getVector() etc.

## Member Data Documentation

SbLineProjector::line`[protected]`

| The projection line. Projected 3D points will be constrained to be on this line.

SbLineProjector::lastPoint`[protected]`

| The last projected point.

The documentation for this class was generated from the following files:

- SbLineProjector.h
- SbLineProjector.cpp